﻿using UnityEngine;
using System.Collections;

public class Character : MonoBehaviour {

	private GameManager GM;
	private KahenManager KM;

	private Animator MyAnimator;
	public float MoveSpeed;
	[HideInInspector]
	public bool walking= false;
	[HideInInspector]
	public bool haveGem= false;
	[HideInInspector]
	public int CurrentTarget;
	public Vector2[] PathPoints;
	public Animator GemAnimator;


	void Awake(){
		MyAnimator = this.GetComponent<Animator> ();
	}

	void Start(){
		GM = GameObject.Find ("GameManagers").GetComponent<GameManager> ();
		KM = GameObject.Find ("KahenManager").GetComponent<KahenManager> ();
		CurrentTarget = 1;
	}

	// Update is called once per frame
	void Update () {
		if (Input.touchCount > 1 || Input.GetKey(KeyCode.Space)) {
			walking = true;
		} else {
			walking = false;
		}

		MyAnimator.SetBool("walking",walking);
		MyAnimator.SetBool("Gem",haveGem);

		if (walking) {
			transform.position = Vector2.MoveTowards (transform.position, PathPoints [CurrentTarget], MoveSpeed * Time.deltaTime);
			//transform.position = Vector2.Lerp (transform.position, PathPoints [CurrentTarget], MoveSpeed * Time.deltaTime);
		}

		if (Vector2.Distance (transform.position, PathPoints [CurrentTarget]) <= 0.5f) {
			if(CurrentTarget < PathPoints.Length-1){
				CurrentTarget += 1;
			}
			else{
				CurrentTarget = 0;
			}
		}
	}

	void OnTriggerEnter2D(Collider2D Other){
		if (Other.tag == "Gem" && !haveGem) {
			haveGem = true;
			MyAnimator.Play("Down_Anim",0,0.01f);
			GemAnimator.SetBool("GemSpawn",false);
		}

		if (Other.tag == "Target" && haveGem) {
			haveGem = false;
			MyAnimator.Play("Up_Anim",0,0.01f);
			GM.CurrentCollectedGems +=1;
			GM.TimeBar.value += 40;
			KM.NextLevel();
			GemAnimator.SetBool("GemSpawn",true);
		}
	}

	public void RandomPlayerAnimation(){
		int anim = Random.Range (1, 4);
		switch (anim) {
		case 1:
			MyAnimator.Play("RitRight_Anim",0,0.01f);
			break;
		case 2:
			MyAnimator.Play("RitUp_Anim",0,0.01f);
			break;
		case 3:
			MyAnimator.Play("RitLeft_Anim",0,0.01f);
			break;
		}

	}

	public void BackToNormalAnimation(){
		MyAnimator.Play("Pray_Anim",0,0.01f);
	}

}
