﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
public class GameManager : MonoBehaviour {

	public Character Player;
	public KahenManager KahenManagerr;
	[HideInInspector]
	public static bool GameisOver = false;
	public Slider TimeBar;
	public GameObject GameOverUI;
	public Text GameOver_Score;
	public Text GameOver_HighScore;
	[HideInInspector]
	public int CurrentCollectedGems;
	public Text GemCountGemText;

	void Update(){
		if (!GameisOver ) {
			TimeBar.value -= KahenManagerr.Levels [KahenManager.CurrentLevel].DecreaseTimeBy / 100;
		}

		if (TimeBar.value == 0) {
			GameOver();
		}

		GemCountGemText.text = (CurrentCollectedGems).ToString();
	}

	public void GameOver(){
		if (!GameisOver) {
			Player.haveGem = false;
			Debug.Log("GameOver");
			Player.enabled = false;
			KahenManagerr.enabled = false;
			GameisOver = true;
			TimeBar.gameObject.SetActive(false);
			Invoke("ActiveGameOverUI",1f);
			GameOver_Score.text = CurrentCollectedGems.ToString();
			if (CurrentCollectedGems> PlayerPrefs.GetInt("HighScore")){
				PlayerPrefs.SetInt("HighScore",CurrentCollectedGems);

			}
			GameOver_HighScore.text = PlayerPrefs.GetInt("HighScore").ToString();
			KahenManagerr.StartAwake = true;
		}
	}

	public void ActiveGameOverUI(){
		GameOverUI.SetActive(true);
	}

	public void RestartGame(){
		Player.haveGem = false;
		Player.GemAnimator.SetTrigger("GemSpawn");
		CurrentCollectedGems = 0;
		Player.CurrentTarget = 1;
		Player.transform.position = Player.PathPoints[0];
		Player.enabled = true;
		TimeBar.value = 100;
		KahenManagerr.ResetKahens ();
		KahenManagerr.enabled = true;
		GameisOver = false;
		TimeBar.gameObject.SetActive(true);
		GameOverUI.SetActive(false);
	}

	public void KillPlayer(){
		KahenManagerr.KillHim ();
	}
}
