﻿using UnityEngine;
using System.Collections;

public class Kahen : MonoBehaviour {

	public enum Rituals {RightRit,LeftRit};

	private GameManager GM;
	private Character Player;
	private KahenManager ManageKahens;
	private bool PlayerInSight;

	public float KillRushSpeed;
	private bool KillHimbool;

	private Vector2 StartPosition;
	private Animator MyAnimator;

	public Rituals FirstRitual;

	void Awake(){
		MyAnimator = this.GetComponent<Animator> ();
		Player = GameObject.Find("Player").GetComponent<Character> ();
		GM = GameObject.Find("GameManagers").GetComponent<GameManager> ();
		ManageKahens = this.GetComponentInParent<KahenManager> ();
	}

	void OnEnable(){
		StartPosition = transform.position;

		MyAnimator.SetInteger ("FirstRitual",(int) FirstRitual);
	}

	void Update(){
		if (Player.walking && PlayerInSight) {
			ManageKahens.KillHim();
		}
		if (KillHimbool) {
			transform.position = Vector2.MoveTowards(transform.position,Player.transform.position,Time.deltaTime * KillRushSpeed);
		}

	}

	public void RandomLookAround(){
		int Ritual = Random.Range(1,4);
		MyAnimator.ResetTrigger("Ritual");
		switch (Ritual) {
		case 1:
			MyAnimator.Play("EnemyAtten_Anim",0,0.01f);
			break;
		case 2:
			MyAnimator.Play("EnemyAtten_Anim 1",0,0.01f);
			MyAnimator.SetInteger("RoL",Random.Range(0,2));
			break;
		}
		if (!GameManager.GameisOver) {
			Invoke("RitualAgain",ManageKahens.RitualTime);
		}
	}

	public void ThePlayerInSight(){
		PlayerInSight = true;
	}

	public void StartNewAwakenTimer(){
		ManageKahens.StartAwake = false;
	}
	
	public void RitualAgain(){
		MyAnimator.SetTrigger("Ritual");
		PlayerInSight = false;
		this.GetComponent<SpriteRenderer> ().color = Color.white;
		Invoke("StartNewAwakenTimer",ManageKahens.AwakenTime);
	}
	
	public void FinalRitual(){
		//EnemyStand_Anim 1
		MyAnimator.ResetTrigger("Ritual");
		MyAnimator.Play ("EnemyStand_Anim 1", 0, 0.01f);
	}
	
	public void KillHim(){
		if (Player.transform.position.x < transform.position.x) {
			MyAnimator.Play ("EnemyLeftAttack_Anim", 0, 0.01f);
		} else if (Player.transform.position.x > transform.position.x) {
			MyAnimator.Play ("EnemyRightAttack_Anim", 0, 0.01f);
		}
		KillHimbool = true;
		GM.GameOver ();
	}

	public void ResetKahen(){
		MyAnimator.Play("EnemyPray_Anim",0,0.01f);
		transform.position = StartPosition;
		KillHimbool = false;
		PlayerInSight = false;
	}

	public void SetGoingLorR(){
		MyAnimator.SetInteger("GoingLorR",0);
	}

	public void SetGoingRorL(){
		MyAnimator.SetInteger("GoingLorR",1);
	}

}
