﻿using UnityEngine;
using System.Collections;

public class KahenManager : MonoBehaviour {

	[System.Serializable]
	public class Level{
		public float DecreaseTimeBy;
		public float MinSecToAwake;
		public float MaxSecToAwake;
		public float MinRitualTime;
		public float MaxRitualTime;
		public bool CanFinalRitual;
	}

	public Character Player;
	public static int CurrentLevel;
	public Level[] Levels;

	public GameObject[] KahenHa;

	[HideInInspector]
	public float AwakenTime =2f;
	[HideInInspector]
	public float RitualTime;
	[HideInInspector]
	public bool StartAwake;


	public Quiz_Script quizScript;

	void OnEnable(){
		AwakenTime = 3f;
		StartAwake = true;
		CurrentLevel =0;
		Invoke("RandomTimeAndInvoke",AwakenTime);
	}

	void Update(){
		if (!StartAwake) {
			RandomTimeAndInvoke();
			StartAwake = true;
		}
	}

	void RandomTimeAndInvoke (){


		AwakenTime = Random.Range (Levels [CurrentLevel].MinSecToAwake, Levels [CurrentLevel].MaxSecToAwake);
		RitualTime = Random.Range (Levels [CurrentLevel].MinRitualTime, Levels [CurrentLevel].MaxRitualTime);

		int KahenCount = Random.Range (1, 5);
		if (KahenCount <= 3) {
			for (int i =KahenCount; i > 0; i--) {
				KahenHa [Random.Range (0, KahenHa.Length)].GetComponent<Kahen> ().RandomLookAround ();
			}
		} else if (KahenCount == 4 && Levels [CurrentLevel].CanFinalRitual) {
			//make all kahens to do final ritual
			foreach (GameObject Kh in KahenHa) {
				Kh.GetComponent<Kahen> ().FinalRitual ();
			}
			Player.enabled = false;
			if(!GameManager.GameisOver){
				quizScript.StartCoroutine (quizScript.StartQuiz ());
			}

		} else if (KahenCount == 4 && !Levels [CurrentLevel].CanFinalRitual) {
			RandomTimeAndInvoke ();
		}
	}

	public void KillHim(){
		foreach(GameObject Kh in KahenHa){
			Kh.GetComponent<Kahen>().KillHim();
		}
	}

	public void EnableCharacter(){
		Player.enabled = true;
	}

	public void ReRitual(){
		foreach(GameObject Kh in KahenHa){
			Kh.GetComponent<Kahen>().RitualAgain();
		}
	}

	public void NextLevel(){
		if (CurrentLevel < Levels.Length - 1) {
			CurrentLevel +=1;
		}
	}

	public void ResetKahens(){
		foreach(GameObject Kh in KahenHa){
			Kh.GetComponent<Kahen>().ResetKahen();
		}
	}

}
