﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using System.Collections.Generic;

public class Quiz_Script : MonoBehaviour {

	public Character Player;
	public GameManager GM;
	public KahenManager KM;
	public GameObject Btns;
	//public Canvas QuizCanvas;
	public Animator QuizAnimator;
	public Sprite[] QuizChoices;
	public List<GameObject> QuizItems;
	//[HideInInspector]
	public float Speed;
	public float MinSpeed;
	public float MaxSpeed;
	[HideInInspector]
	public string CurrentGoal;
	public SpriteRenderer Green;
	[HideInInspector]
	public GameObject ItemToDelete;
	private int Clicks;
	//public static bool IsQuiz;
	//public GameObject[] ActiveItems;
	
	public IEnumerator StartQuiz( ){
		//IsQuiz = true;
			Btns.SetActive (true);
			//StartTimer = false;
			//QuizCanvas.enabled = true;
			QuizAnimator.SetTrigger ("Qback_Trigger");

			yield return new WaitForSeconds (1f);
			GameObject[] ActiveItems = new GameObject[10];
			int n = 0;
			bool first = true;
			foreach (GameObject g in QuizItems) {
				if (first) {
					g.SetActive (true);
					ActiveItems [n] = g;
					n++;
					first = false;
				} else {
					switch (Random.Range (0, 2)) {
					case 0:
						g.SetActive (true);
						ActiveItems [n] = g;
						n++;
						break;
					case 1:
						break;
					}
				}
			}
			for (int i = 1; i < n; i++) {
				int distance = Random.Range (4, 7);
				ActiveItems [i].transform.position = new Vector2 (ActiveItems [i - 1].transform.position.x + distance, ActiveItems [i - 1].transform.position.y);
			}
			Speed = Random.Range (MinSpeed, MaxSpeed);
			for (int i = 0; i < n; i++) {
				ActiveItems [i].GetComponent<SpriteRenderer> ().sprite = QuizChoices [Random.Range (0, QuizChoices.Length)];
				ActiveItems [i].GetComponent<ChoiceMove_Script> ().enabled = true;
			}
			Clicks = n;
		Player.RandomPlayerAnimation();
	}

	public void Btn1_Click(){
		if(QuizChoices[0].name == CurrentGoal){
			Green.color = new Color32(0,255,86,190);
			ItemToDelete.SetActive(false);
			ItemToDelete.transform.position  =new Vector2 (6f,-4.85f);
			ItemToDelete.GetComponent<ChoiceMove_Script>().enabled = false;
			ItemToDelete.GetComponent<SpriteRenderer>().sprite = null;
			CurrentGoal = "";

			Clicks -=1;
			Player.RandomPlayerAnimation();
			if(Clicks == 0){
				DoneSequence();
			}
		}
		else{
			Green.color = new Color32(255,0,0,190);
			GameOver();

		}
	}
	public void Btn2_Click(){
		if(QuizChoices[1].name == CurrentGoal){
			Green.color = new Color32(0,255,86,100);
			ItemToDelete.SetActive(false);
			ItemToDelete.transform.position  =new Vector2 (6f,-4.85f);
			ItemToDelete.GetComponent<ChoiceMove_Script>().enabled = false;
			ItemToDelete.GetComponent<SpriteRenderer>().sprite = null;
			CurrentGoal = "";

			Clicks -= 1;
			Player.RandomPlayerAnimation();
			if(Clicks == 0){
				DoneSequence();
			}
		}
		else{
			Green.color = new Color32(255,0,0,100);
			GameOver();
			
		}
	}
	public void Btn3_Click(){
		if(QuizChoices[2].name == CurrentGoal){
			Green.color = new Color32(0,255,86,100);
			ItemToDelete.SetActive(false);
			ItemToDelete.transform.position  =new Vector2 (6f,-4.85f);
			ItemToDelete.GetComponent<ChoiceMove_Script>().enabled = false;
			ItemToDelete.GetComponent<SpriteRenderer>().sprite = null;
			CurrentGoal = "";

			Clicks -=1;
			Player.RandomPlayerAnimation();
			if(Clicks == 0){
				DoneSequence();
			}
		}
		else{
			Green.color = new Color32(255,0,0,100);
			GameOver();
			
		}
	}
	public void Btn4_Click(){
		if(QuizChoices[3].name == CurrentGoal){
			Green.color = new Color32(0,255,86,100);
			ItemToDelete.SetActive(false);
			ItemToDelete.transform.position  =new Vector2 (6f,-4.85f);
			ItemToDelete.GetComponent<ChoiceMove_Script>().enabled = false;
			ItemToDelete.GetComponent<SpriteRenderer>().sprite = null;
			CurrentGoal = "";

			Clicks -=1;
			Player.RandomPlayerAnimation();
			if(Clicks == 0){
				DoneSequence();
			}
		}
		else{
			Green.color = new Color32(255,0,0,100);
			GameOver();
		}
	}

	void DoneSequence(){
		Player.BackToNormalAnimation ();
		QuizAnimator.SetTrigger("QbackRev_Trigger");
		Btns.SetActive(false);
		KM.ReRitual();
		KM.EnableCharacter ();
	}
	
	public void GameOver(){
		Player.BackToNormalAnimation ();
		QuizAnimator.SetTrigger("QbackRev_Trigger");
		Btns.SetActive(false);
		GM.KillPlayer ();
		Btns.SetActive(false);
		ResetQuiz ();
	}

	public void ResetQuiz(){
		Player.BackToNormalAnimation ();
		//IsQuiz = false;
		Green.color = new Color32(255,255,255,255);
		//QuizAnimator.ResetTrigger("QbackRev_Trigger");
		CurrentGoal = "";
		foreach(GameObject Go in QuizItems){
			Go.transform.position = new Vector2(6,-4.85f);
			Go.GetComponent<ChoiceMove_Script>().enabled = false;
			Go.GetComponent<SpriteRenderer>().sprite = null;
		}
	}
}
